/*******************************************************************************
 * Copyright (c) 2011 Martin Schwengerer.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Martin Schwengerer - initial API and implementation
 ******************************************************************************/
package aspmodificator.model;

public abstract class LineBase {

	protected int startLineNo = -1;
	protected boolean modified = false;
	protected boolean cloned = false;

	public LineBase() {

	}

	protected LineBase(int startLineNo) {
		this.startLineNo = startLineNo;

	}

	public abstract Object clone() throws CloneNotSupportedException;

	public int getStartLineNo() {
		return startLineNo;
	}

	public boolean isCloned() {
		return cloned;
	}

	public boolean isModified() {
		return modified;
	}

	public void setCloned(boolean cloned) {
		this.cloned = cloned;
	}

	public void setModified(boolean modified) {
		this.modified = modified;
	}

	public void setStartLineNo(int startLineNo) {
		this.startLineNo = startLineNo;
	}

	public abstract String toOutputString();

	public abstract String toString();
}
