/*******************************************************************************
 * Copyright (c) 2011 Martin Schwengerer.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Martin Schwengerer - initial API and implementation
 ******************************************************************************/
package aspmodificator.modificationrules;

import java.util.List;
import java.util.Random;

import aspmodificator.model.LineBase;
import aspmodificator.modificationrules.gringo.ModificationRuleTypeEnum;

public interface IModificationRule {

	/**
	 * Applies the modificationRule on the program and may changes it
	 * 
	 * @param program
	 *            program to be changed
	 * @return number of changes
	 * @throws Exception
	 */
	int apply(List<LineBase> program) throws Exception;

	ModificationRuleTypeEnum getRuleTypeEnum();

	void setRandom(Random rand);

	void setTabuList(TabuList tabuList);

	void setUseMemory(boolean useMemory);

	void setWriteComments(boolean writeComments);
}
