/*******************************************************************************
 * Copyright (c) 2011 Martin Schwengerer.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Martin Schwengerer - initial API and implementation
 ******************************************************************************/
package aspmodificator.modificationrules.gringo;

import java.util.Random;

import aspmodificator.modificationrules.IModificationRule;
import aspmodificator.modificationrules.TabuList;

public abstract class AbstractModificationRule implements IModificationRule {

	protected Random random;

	protected int minApplication;
	protected int maxApplication;

	protected boolean writeComments = true;

	protected boolean useMemory = false;
	protected TabuList tabuList = null;

	protected RuleTargetEnum mrRuleTarget = RuleTargetEnum.ALL;

	public AbstractModificationRule() {
		random = new Random();
	}

	public AbstractModificationRule(int min, int max) {
		this();
		minApplication = min;
		maxApplication = max;
	}

	public int getMaxApplication() {
		return maxApplication;
	}

	public int getMinApplication() {
		return minApplication;
	}

	public RuleTargetEnum getMrRuleTarget() {
		return mrRuleTarget;
	}

	public void setMaxApplication(int maxApplication) {
		this.maxApplication = maxApplication;
	}

	public void setMinApplication(int minApplication) {
		this.minApplication = minApplication;
	}

	public void setMrRuleTarget(RuleTargetEnum ruleTarget) {
		this.mrRuleTarget = ruleTarget;
	}

	@Override
	public void setRandom(Random rand) {
		this.random = rand;
	}

	@Override
	public void setTabuList(TabuList tabuList) {
		this.tabuList = tabuList;
	}

	@Override
	public void setUseMemory(boolean useMemory) {
		this.useMemory = useMemory;
	}

	@Override
	public void setWriteComments(boolean writeComments) {
		this.writeComments = writeComments;
	}

}
