/*******************************************************************************
 * Copyright (c) 2011 Martin Schwengerer.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Martin Schwengerer - initial API and implementation
 ******************************************************************************/
package aspmodificator.modificationrules.gringo;

import java.util.ArrayList;
import java.util.List;

import aspmodificator.model.LineBase;
import aspmodificator.parser.gringo.GringoRule;
import aspmodificator.parser.gringo.Literal;

public class RemoveDefaultNegationModificationRule extends
		SwitchDefaultNegationModificationRule {

	public RemoveDefaultNegationModificationRule() {
		super();
	}

	public RemoveDefaultNegationModificationRule(int minApplication,
			int maxApplication) {
		super(minApplication, maxApplication);
	}

	@Override
	protected List<Literal> findApplicableObjects(List<LineBase> program) {
		List<Literal> result = new ArrayList<Literal>();

		for (LineBase line : program) {
			if (GringoRule.class.isAssignableFrom(line.getClass())) {
				GringoRule rule = (GringoRule) line;

				/*
				 * if (rule.getHead() != null) { for (Literal lit :
				 * rule.getHead()) { if (allowsDefaultNegation(lit.getClass())
				 * && !lit.isModified()) result.add(lit); } }
				 */
				if (rule.getBody() != null) {
					for (Literal lit : rule.getBody()) {
						if (allowsDefaultNegation(lit.getClass())
								&& !lit.isModified() && lit.isSigned())
							result.add(lit);
					}
				}
			}
		}

		return result;
	}

	@Override
	protected void modifyLiteral(Literal lit) {

		lit.setSigned(false);

		if (writeComments) {
			lit.addSucceedingComment(COMMENT_REMOVED);
		}
	}

}
