/*******************************************************************************
 * Copyright (c) 2011 Martin Schwengerer.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Martin Schwengerer - initial API and implementation
 ******************************************************************************/
package aspmodificator.parser;

import java.io.StringReader;
import java.util.List;

import java_cup.runtime.Symbol;

import aspmodificator.model.LineBase;

import aspmodificator.parser.gringo.Lexer;
import aspmodificator.parser.gringo.Parser;

public class GringoParser implements IFileParser {

	@SuppressWarnings("unchecked")
	@Override
	public List<LineBase> parse(String str) throws Exception {
		Lexer l = new Lexer(new StringReader(str));
		Parser parser = new Parser(l);
		try {
			Symbol parseTree = parser.parse();
			return (List<LineBase>) parseTree.value;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

}
