/*******************************************************************************
 * Copyright (c) 2011 Martin Schwengerer.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Martin Schwengerer - initial API and implementation
 ******************************************************************************/
package aspmodificator.parser.gringo;

import java.util.ArrayList;
import java.util.List;

public class ArgTerm extends Term {

	private Term term_;

	protected ArgTerm() {
		super();
	}

	public ArgTerm(Term term, List<Term> terms, int lineNo) {
		super(";;", new ArrayList<Literal>(terms), lineNo);
		term_ = term;
	}

	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		if (precedingComments != null && precedingComments.size() > 0) {
			for (BlockComment bc : precedingComments) {
				sb.append(bc.getText());
			}
		}
		sb.append(term_.toString());
		sb.append(";;");

		boolean comma = false;
		for (Literal t : terms) {
			if (comma)
				sb.append(",");
			else
				comma = true;
			sb.append(t.toString());
		}

		if (succeedingComments != null && succeedingComments.size() > 0) {
			for (BlockComment bc : succeedingComments) {
				sb.append(bc.getText());
			}
		}
		return sb.toString();
	}

}
