/*******************************************************************************
 * Copyright (c) 2011 Martin Schwengerer.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Martin Schwengerer - initial API and implementation
 ******************************************************************************/
package aspmodificator.parser.gringo;

import java.util.ArrayList;
import java.util.List;

public class ComputeLiteral extends Literal {

	private List<Literal> conditionList;

	public ComputeLiteral(Literal head, List<Literal> conditions, int lineNo) {
		super(head);
		this.lineNo = lineNo;
		this.conditionList = conditions;
	}

	@Override
	public Object clone() throws CloneNotSupportedException {
		if (conditionList != null && conditionList.size() > 0) {
			List<Literal> tmpList = new ArrayList<Literal>();
			for (Literal lit : conditionList) {
				tmpList.add((Literal) lit.clone());
			}
			return new ComputeLiteral((Literal) super.clone(), tmpList, lineNo);
		} else
			return new ComputeLiteral((Literal) super.clone(), null, lineNo);
	}

	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(super.toString());

		if (conditionList != null && !conditionList.isEmpty()) {

			for (Literal lit : conditionList) {
				sb.append(" : ");
				sb.append(lit.toString());
			}
		}

		return sb.toString();
	}

}
