/*******************************************************************************
 * Copyright (c) 2011 Martin Schwengerer.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Martin Schwengerer - initial API and implementation
 ******************************************************************************/
package aspmodificator.parser.gringo;

import java.util.ArrayList;
import java.util.List;

public class FuncTerm extends Term {
	protected FuncTerm() {
		super();
	}

	public FuncTerm(String id, List<Term> args) {
		super(id, new ArrayList<Literal>(args));
	}

	public FuncTerm(String id, List<Term> args, int lineNo) {
		super(id, new ArrayList<Literal>(args), lineNo);
	}

	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();

		if (identifier != null)
			sb.append(identifier);

		if (terms != null && terms.size() > 0) {
			sb.append("(");

			for (int i = 0; i < terms.size() - 1; i++) {
				sb.append(terms.get(i).toString());
				sb.append(", ");
			}

			sb.append(terms.get(terms.size() - 1).toString());
			sb.append(")");
		}

		return sb.toString();
	}

}
