/*******************************************************************************
 * Copyright (c) 2011 Martin Schwengerer.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Martin Schwengerer - initial API and implementation
 ******************************************************************************/
package aspmodificator.parser.gringo;

import aspmodificator.model.LineBase;

public class IncrementalStatement extends LineBase {

	public enum IncrementalStatementEnum {
		UNKNOWN, BASE, VOLATILE, CUMULATIVE
	};

	private IncrementalStatementEnum type = IncrementalStatementEnum.UNKNOWN;
	private String id = null;

	public IncrementalStatement(IncrementalStatementEnum type, String id,
			int startLineNo) {
		super(startLineNo);
		this.type = type;
		this.id = id;
	}

	@Override
	public Object clone() throws CloneNotSupportedException {
		return new IncrementalStatement(type, id, startLineNo);
	}

	@Override
	public String toOutputString() {
		return toString();
	}

	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		switch (type) {
		case UNKNOWN:
			break;
		case BASE:
			sb.append("#base");
			break;
		case CUMULATIVE:
			sb.append("#cumulative");
			break;
		case VOLATILE:
			sb.append("#volatile");
			break;
		}

		if (id != null) {
			sb.append(" ");
			sb.append(id);
		}
		sb.append(".");
		return sb.toString();
	}

}
