/*******************************************************************************
 * Copyright (c) 2011 Martin Schwengerer.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Martin Schwengerer - initial API and implementation
 ******************************************************************************/
package aspmodificator.parser.gringo;

public class Signed extends Predicate {

	private String identification;
	private boolean minus;
	private int lineNo;

	public Signed(String id, boolean minus) {
		this.identification = id;
		this.minus = minus;
	}

	public Signed(String id, boolean minus, int lineNo) {
		this.identification = id;
		this.minus = minus;
		this.lineNo = lineNo;
	}

	@Override
	public Object clone() throws CloneNotSupportedException {
		return new Signed(identification, minus);
	}

	public int getLineNo() {
		return lineNo;
	}

	@Override
	public String toString() {
		if (minus)
			return "-" + identification;
		else
			return identification;
	}

}
