/*******************************************************************************
 * Copyright (c) 2011 Martin Schwengerer.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Martin Schwengerer - initial API and implementation
 ******************************************************************************/
package aspmodificator.parser.gringo;

import java.util.List;

public class Term extends Literal {

	protected Term() {
		super();
	}

	public Term(String string) {
		super(string, null, false);
	}

	public Term(String id, int lineNo) {
		super(id, null, false, lineNo);
	}

	protected Term(String id, List<Literal> list) {
		super(id, list, false);
	}

	public Term(String id, List<Literal> list, int lineNo) {
		super(id, list, false, lineNo);
	}

	@Override
	public void setSigned(boolean signed) {
		/* do nothing - terms cannot have a default negation */
		this.signed = false;
	}

	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		if (precedingComments != null && precedingComments.size() > 0) {
			for (BlockComment bc : precedingComments) {
				sb.append(bc.getText());
			}
		}
		sb.append(identifier);

		if (succeedingComments != null && succeedingComments.size() > 0) {
			for (BlockComment bc : succeedingComments) {
				sb.append(bc.getText());
			}
		}
		return sb.toString();
	}

}
